/*
  ____   __   __     _      ____   __   __  _   _   ____    _   _   _  __     _    
 |  _ \  \ \ / /    / \    |  _ \  \ \ / / | | | | / ___|  | | | | | |/ /    / \   
 | | | |  \ V /    / _ \   | | | |  \ V /  | | | | \___ \  | |_| | | ' /    / _ \  
 | |_| |   | |    / ___ \  | |_| |   | |   | |_| |  ___) | |  _  | | . \   / ___ \ 
 |____/    |_|   /_/   \_\ |____/    |_|    \___/  |____/  |_| |_| |_|\_\ /_/   \_\
                                                                                   
  ____   __   __     _      ____   __   __     _    
 |  _ \  \ \ / /    / \    |  _ \  \ \ / /    / \   
 | | | |  \ V /    / _ \   | | | |  \ V /    / _ \  
 | |_| |   | |    / ___ \  | |_| |   | |    / ___ \ 
 |____/    |_|   /_/   \_\ |____/    |_|   /_/   \_\
                                                    
  _____   ____    ___   _____   _____   ____  
 | ____| |  _ \  |_ _| |_   _| | ____| |  _ \ 
 |  _|   | | | |  | |    | |   |  _|   | | | |
 | |___  | |_| |  | |    | |   | |___  | |_| |
 |_____| |____/  |___|   |_|   |_____| |____/ 
                                              
*/
using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine.Events;
using TMPro;
using UnityEngine.SceneManagement;
using System.Linq;
using UnityEngine.UI;

namespace Mod
{
	public class Mod : MonoBehaviour
	{
		public static Map[] Maps;
		public static Map Vol;
		public static Sprite TemplateSprite = ModAPI.LoadSprite("TEMPLATE.png");
		public static string mapname;
		public static MapSelectionMenuBehaviour mapmenu = UnityEngine.Object.FindObjectOfType<MapSelectionMenuBehaviour>();
		public static bool debounce = false;
		public static Sprite Square = ModAPI.LoadSprite("black.png");
		public static Sprite Lava = ModAPI.LoadSprite("Lava.png");
		public static Sprite Acid = ModAPI.LoadSprite("Acid.png");
		public static AudioClip acidhiss = ModAPI.LoadSound("Hiss.wav");
		public static bool Done = false;
		public static string MapModName = "";
		public static string MapName = "PPG Big City";
		public static Sprite CustomSprite1 = ModAPI.LoadSprite("CustomSprite1.png");
        public static Sprite CustomSprite2 = ModAPI.LoadSprite("CustomSprite2.png");
        public static Sprite CustomSprite4 = ModAPI.LoadSprite("CustomSprite4.png");
        public static Sprite CustomSprite6 = ModAPI.LoadSprite("CustomSprite6.png");
        public static Sprite CustomSprite7 = ModAPI.LoadSprite("CustomSprite7.png");
        public static Sprite CustomSprite8 = ModAPI.LoadSprite("CustomSprite8.png");
        public static Sprite CustomSprite10 = ModAPI.LoadSprite("CustomSprite10.png");
        public static Sprite CustomSprite11 = ModAPI.LoadSprite("CustomSprite11.png");
        public static Sprite CustomSprite13 = ModAPI.LoadSprite("CustomSprite13.png");
		public static Sprite ASS = ModAPI.LoadSprite("ASS.png");

		public static PhysicalProperties phys = ModAPI.FindPhysicalProperties("Soft");

		public static void OnLoad()
		{
			phys.Brittleness = 0f;
			phys.Buoyancy = 0f;
			phys.Flammability = 0f;
			phys.MagneticAttractionIntensity = 0f;
			phys.Conducting = false;
			phys.Burnrate = 0f;
			phys.ImpactIntensityMutliplier = 1f;
			phys.HitVolumeMultiplier = 1f;
			phys.BulletSpeedAbsorptionPower = 0f;
			phys.Softness = 0.1f;
			phys.LodgeStrengthMultiplier = 0.1f;
			phys.SharpForceThresholdMultiplier = 1f;
			// 
			Map MapMod = ScriptableObject.CreateInstance<Map>();
			MapMod.name = MapName;
			MapMod.UniqueIdentity = Guid.NewGuid().ToString();
			MapMod.Description = "Map";
			MapMod.Thumbnail = ModAPI.LoadSprite("TEMPLATE.png");
			MapMod.Preview = ModAPI.LoadSprite("TEMPLATE.png");
			MapMod.Prefab = MapRegistry.GetAllMaps().ElementAt(2).Prefab;
			MapModName = MapMod.name;
			MapRegistry.Register(MapMod);
		}

		public static void RemoveBorders()
		{
			foreach (var render in GameObject.Find("Root").transform.parent.GetComponentsInChildren<SpriteRenderer>())
			{
				if (render.gameObject.layer == LayerMask.NameToLayer("Bounds") && render.gameObject.GetComponent<Undraggable>())
				{
					Destroy(render.gameObject);
				}
			}

			Map eggs = Resources.Load<Map>("Maps/Humongous");
			foreach (MapLightBehaviour light in UnityEngine.Object.FindObjectsOfType<MapLightBehaviour>())
			{
				Destroy(light.gameObject);
			}
			var thing = Instantiate<GameObject>(eggs.Prefab.transform.Find("Lightbulb/BulbGlow/full ambient").gameObject);
			thing.transform.position = new Vector2(500f, 100f);
			thing.transform.localScale = new Vector2(100000f, 100000f);
			thing.GetComponent<SpriteRenderer>().material.SetFloat("_GlowIntensity", 1.2f);
			thing.GetComponent<SpriteRenderer>().material.SetColor("_GlowColour", new Color32(255, 255, 255, 225));
			if (GameObject.Find("Panels"))
			{
				GameObject.Find("Panels").transform.localScale = new Vector2(100000f, 100000f);
			}
			MapConfig mapconfig = UnityEngine.Object.FindObjectOfType<MapConfig>();
			mapconfig.GetComponent<BoundingBoxBehaviour>().BoundingBox = new Bounds(new Vector3(500f, 250f, 0f), new Vector3(1500000f, 1500000f, 0f));
		}

		public static void CreateGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, string Layer, bool NoCollision, int Order = 0)
		{
			var NewGameobject = ModAPI.CreatePhysicalObject(Name, Mod.Square);
			NewGameobject.tag = "NoClear";
			NewGameobject.layer = LayerMask.NameToLayer("Bounds");
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.position = Pos;
			if (Layer == "Front")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Top");
			}
			if (Layer == "Back")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
			}
			NewGameobject.transform.rotation = Rotation;
			if (NoCollision)
			{
				NewGameobject.GetComponent<Collider2D>().enabled = false;
			}
			NewGameobject.transform.parent = GameObject.Find("Root").transform.parent;
			NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = Order;
			NewGameobject.AddComponent<Undraggable>();
			NewGameobject.GetComponent<Rigidbody2D>().constraints = RigidbodyConstraints2D.FreezeAll;
			NewGameobject.AddComponent<ContextMenuOptionComponent>();
			PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
			physicalBehaviour.Properties = Mod.phys;
			physicalBehaviour.SpawnSpawnParticles = false;
			physicalBehaviour.OverrideShotSounds = new AudioClip[0];
			physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
			physicalBehaviour.Deletable = false;
			physicalBehaviour.Disintegratable = false;
			physicalBehaviour.DisplayBloodDecals = false;
			physicalBehaviour.ChargeBurns = false;
			physicalBehaviour.SimulateTemperature = false;
			///NewGameobject.AddComponent<AudioSource>();
			///NewGameobject.AddComponent<AudioSourceTimeScaleBehaviour>();
			NewGameobject.AddComponent<TestDelay>();
		}

		public static void CreateCustomGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Sprite spritey, string Layer, bool NoCollision, int Order = 0)
		{
			var NewGameobject = ModAPI.CreatePhysicalObject(Name, spritey);
			NewGameobject.tag = "NoClear";
			NewGameobject.layer = LayerMask.NameToLayer("Bounds");
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			NewGameobject.FixColliders();
			if (Layer == "Front")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Top");
			}
			if (Layer == "Back")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
			}
			if (NoCollision)
			{
				foreach (var col in NewGameobject.GetComponents<Collider2D>())
				{
					col.enabled = false;
				}
			}
			NewGameobject.transform.parent = GameObject.Find("Root").transform.parent;
			NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = Order;
			NewGameobject.GetComponent<Rigidbody2D>().constraints = RigidbodyConstraints2D.FreezeAll;
			NewGameobject.AddComponent<Undraggable>();
			NewGameobject.AddComponent<ContextMenuOptionComponent>();
			PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
			physicalBehaviour.Properties = Mod.phys;
			physicalBehaviour.SpawnSpawnParticles = false;
			physicalBehaviour.OverrideShotSounds = new AudioClip[0];
			physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
			physicalBehaviour.Deletable = false;
			physicalBehaviour.Disintegratable = false;
			physicalBehaviour.DisplayBloodDecals = false;
			physicalBehaviour.ChargeBurns = false;
			physicalBehaviour.SimulateTemperature = false;
			physicalBehaviour.rigidbody = NewGameobject.GetComponent<Rigidbody2D>();
			///NewGameobject.AddComponent<AudioSource>();
			///NewGameobject.AddComponent<AudioSourceTimeScaleBehaviour>();
			NewGameobject.AddComponent<TestDelay>();
		}

		public static void CreateSpawnable(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, bool FacingRight, bool Frozen)
		{
			GameObject NewGameobject = Instantiate<GameObject>(ModAPI.FindSpawnable(Name).Prefab, Vector3.zero, Quaternion.identity);
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			if (!FacingRight)
			{
				NewGameobject.transform.localScale = new Vector2(-NewGameobject.transform.localScale.x, NewGameobject.transform.localScale.y);
			}
			if (Frozen)
			{
				NewGameobject.AddComponent<TestDelay>();
			}
		}

		public static void CreatePhysicsGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Sprite spritey, string Layer, bool NoCollision)
		{
			var NewGameobject = ModAPI.CreatePhysicalObject(Name, spritey);
			if (Layer == "Front")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Objects");
			}
			if (Layer == "Back")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
			}
			NewGameobject.tag = "NoClear";
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			NewGameobject.FixColliders();
			PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
			if (NoCollision)
			{
				NewGameobject.GetComponent<Collider2D>().enabled = false;
			}
			physicalBehaviour.OverrideShotSounds = new AudioClip[0];
			physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
		}

		public static void CreateLightSourceStreet(String Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Color32 color, float brightness)
		{
			var NewGameobject = new GameObject();
			NewGameobject.tag = "NoClear";
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			var light = ModAPI.CreateLight(NewGameobject.transform, color, brightness*25);
			light.gameObject.tag = "NoClear";
		}
		public static void CreateLightSources(String Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Color32 color, float brightness)
		{
			var NewGameobject = new GameObject();
			NewGameobject.tag = "NoClear";
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			float Sex = UnityEngine.Random.Range(4.25f, 6.75f);
			var light = ModAPI.CreateLight(NewGameobject.transform, color, brightness * Sex);
			light.gameObject.tag = "NoClear";
		}
		public static void CreateBackground(
			  string Name,
			  Color32 color,
			  Sprite spritey,
			  bool IsTexture)
		{
			GameObject gameObject = new GameObject();
			gameObject.tag = "NoClear";
			gameObject.transform.position = (Vector3)new Vector2(572.314f, 496.2918f);
			Texture2D whiteTexture = Texture2D.whiteTexture;
			whiteTexture.Resize(16, 16);
			whiteTexture.Apply();
			if (IsTexture)
			{
				Texture2D texture1 = new Texture2D((int)spritey.rect.width, (int)spritey.rect.height);
				Texture2D texture2 = spritey.texture;
				int x = (int)spritey.textureRect.x;
				Rect textureRect = spritey.textureRect;
				int y = (int)textureRect.y;
				textureRect = spritey.textureRect;
				int width = (int)textureRect.width;
				textureRect = spritey.textureRect;
				int height = (int)textureRect.height;
				Color[] pixels = texture2.GetPixels(x, y, width, height);
				texture1.SetPixels(pixels);
				texture1.wrapMode = TextureWrapMode.Repeat;
				texture1.filterMode = FilterMode.Point;
				texture1.Apply();
				Sprite sprite = Sprite.Create(texture1, new Rect(0.0f, 0.0f, (float)texture1.width, (float)texture1.height), 0.5f * Vector2.one, 140f, 0U, SpriteMeshType.FullRect);
				gameObject.AddComponent<SpriteRenderer>().drawMode = SpriteDrawMode.Tiled;
				gameObject.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("Sprites-Default");
				gameObject.GetComponent<SpriteRenderer>().sprite = sprite;
				gameObject.GetComponent<SpriteRenderer>().size = new Vector2(5f, 5f);
				gameObject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
				gameObject.GetComponent<SpriteRenderer>().sortingOrder = -999999;
			}
			else
			{
				gameObject.AddComponent<SpriteRenderer>().sprite = Sprite.Create(whiteTexture, new Rect(0.0f, 0.0f, 16f, 16f), 0.5f * Vector2.one, 35f);
				gameObject.GetComponent<SpriteRenderer>().color = (Color)color;
				gameObject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
				gameObject.GetComponent<SpriteRenderer>().sortingOrder = -999999;
			}
			gameObject.transform.localScale = (Vector3)new Vector2(2533.112f, 2175.462f);
			gameObject.transform.parent = GameObject.Find("Root").transform.parent;
			gameObject.layer = LayerMask.NameToLayer("Bounds");
		}

		public static void CreateParticleSources(string Name, Vector2 Pos, float Speed, string Particles)
		{
			var NewGameobject = new GameObject();
			NewGameobject.tag = "NoClear";
			NewGameobject.name = Name;
			NewGameobject.transform.position = Pos;
			NewGameobject.AddComponent<ParticleDelay>();
			NewGameobject.GetComponent<ParticleDelay>().Speed1 = Speed;
			NewGameobject.GetComponent<ParticleDelay>().Particles1 = Particles;
		}

		public static void AddAudioToAmbience(float Bacon, AudioClip[] Eggs)
		{
			///Changing this to other variables in the MapConfig will let you force snow on and other stuff.
			MapConfig mapconfig = UnityEngine.Object.FindObjectOfType<MapConfig>();
			///mapconfig.OverrideAmbientSounds = true;
			var hhh = mapconfig.transform.parent.GetComponent<PlayAudioAtRandom>();
			hhh.Clips = Eggs;
			hhh.ChancePerSecond = Bacon;
		}

		public static void CreateWaterBlock(Vector3 Size, Vector3 Pos, Quaternion Rotation, string Type)
		{
			Map eggs = Resources.Load<Map>("Maps/Sea");
			GameObject WaterBefore = eggs.Prefab.transform.Find("Root/Sea").gameObject;
			var Water = Instantiate<GameObject>(WaterBefore, Vector3.zero, Quaternion.identity);
			Water.transform.rotation = Rotation;
			Water.transform.localScale = new Vector2(Size.x, -Size.y);
			///Water.transform.SetParent(GameObject.Find("Root").transform);
			Water.transform.localPosition = Pos;
			Water.AddComponent<WaterBlockBehaviour>().GlobalTop = Water.GetComponent<SpriteRenderer>().bounds.max.y;
			Water.GetComponent<WaterBlockBehaviour>().GlobalBottom = Water.GetComponent<SpriteRenderer>().bounds.min.y;
			Water.GetComponent<WaterBlockBehaviour>().GlobalLeft = Water.GetComponent<SpriteRenderer>().bounds.min.x;
			Water.GetComponent<WaterBlockBehaviour>().GlobalRight = Water.GetComponent<SpriteRenderer>().bounds.max.x;
			Water.GetComponent<WaterBlockBehaviour>().WaterSize = Size;
			Water.GetComponent<WaterBlockBehaviour>().WaterCenter = Pos;
			Water.GetComponent<WaterBlockBehaviour>().Drag = Water.GetComponent<WaterBehaviour>().Drag;
			Water.GetComponent<WaterBlockBehaviour>().Buoyancy = Water.GetComponent<WaterBehaviour>().Buoyancy;
			Water.GetComponent<WaterBlockBehaviour>().Trigger = Water.GetComponent<WaterBehaviour>().Trigger;
			Water.GetComponent<WaterBlockBehaviour>().Splash = UnityEngine.Object.Instantiate<GameObject>(Water.GetComponent<WaterBehaviour>().Splash);
			Water.GetComponent<WaterBlockBehaviour>().Splash.SetActive(false);
			Water.GetComponent<WaterBlockBehaviour>().Layers = Water.GetComponent<WaterBehaviour>().Layers;
			Water.GetComponent<WaterBlockBehaviour>().ObjectsToBeActiveIfWater = Water.GetComponent<WaterBehaviour>().ObjectsToBeActiveIfWater;
			Water.GetComponent<WaterBlockBehaviour>().BoilingWaterSound = Water.GetComponent<WaterBehaviour>().BoilingWaterSound;
			Water.GetComponent<WaterBlockBehaviour>().Ice = Water.GetComponent<WaterBehaviour>().Ice;
			Water.GetComponent<WaterBehaviour>().enabled = false;
			WaterBlockBehaviour.Instance = Water.GetComponent<WaterBlockBehaviour>();
			var main = Water.GetComponentInChildren<ParticleSystem>().main;
			var shape = Water.GetComponentInChildren<ParticleSystem>().shape;
			var emission = Water.GetComponentInChildren<ParticleSystem>().emission;
			main.scalingMode = ParticleSystemScalingMode.Shape;
			shape.scale = Size;
			shape.rotation = Water.transform.eulerAngles;
			emission.rateOverTimeMultiplier = 1f * (Size.x / 4.8f);
			if (Type == "Lava")
			{
				Water.GetComponent<SpriteRenderer>().drawMode = SpriteDrawMode.Tiled;
				Water.GetComponent<SpriteRenderer>().tileMode = SpriteTileMode.Continuous;
				Water.GetComponent<SpriteRenderer>().sprite = Mod.Lava;
				Water.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("Sprites-Default");
				Water.GetComponent<WaterBlockBehaviour>().Lava = true;
				var light = ModAPI.CreateLight(Water.transform, new Color32(255, 129, 32, 255), 15, 5);
				Water.AddComponent<LavaBurn>();
				foreach (var particle in Water.GetComponent<WaterBlockBehaviour>().Splash.GetComponentsInChildren<ParticleSystem>())
				{
					var shape2 = particle.shape;
					var main2 = particle.main;
					shape2.texture = Mod.Lava.texture;
					main2.startColor = new Color(1f, 0.5f, 0.12f, 1f);
				}
				Water.GetComponent<WaterBlockBehaviour>().Buoyancy = 0f;
				Water.GetComponent<WaterBlockBehaviour>().Drag += 0.6f;
			}
			else if (Type == "Acid")
			{
				Water.GetComponent<SpriteRenderer>().color = new Color(0, 1, 0, 1);
				Water.GetComponent<SpriteRenderer>().drawMode = SpriteDrawMode.Tiled;
				Water.GetComponent<SpriteRenderer>().tileMode = SpriteTileMode.Continuous;
				Water.GetComponent<SpriteRenderer>().sprite = Mod.Acid;
				Water.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("Sprites-Default");
				var AcidLight = ModAPI.CreateLight(Water.transform, new Color(0, 1, 0, 1), 4, 3);
				Water.GetComponent<WaterBlockBehaviour>().Lava = true;
				Water.AddComponent<AcidBurn>();
				foreach (var particle in Water.GetComponent<WaterBlockBehaviour>().Splash.GetComponentsInChildren<ParticleSystem>())
				{
					var shape2 = particle.shape;
					var main2 = particle.main;
					shape2.texture = Mod.Acid.texture;
					main2.startColor = new Color(0, 1, 0, 0.8f);
				}
				Water.GetComponent<WaterBlockBehaviour>().Buoyancy -= 0.1f;
				Water.GetComponent<WaterBlockBehaviour>().Drag += 0.4f;
			}
			GameObject.Destroy(Water.GetComponent<WaterBehaviour>());
		}

		public static void Main()
		{
			///Don't do anything yet.
			if (MapLoaderBehaviour.CurrentMap.name == MapModName)
			{
				Debug.Log("Setting up some stuff.");
				var manager = new GameObject("managerMap");
				manager.AddComponent<MapModManager>();
			}
		}
		public static void InitilizeMap()
		{
			foreach (var waterBlock in GameObject.FindObjectsOfType<WaterBlockBehaviour>())
			{
				GameObject.Destroy(waterBlock.gameObject);
			}
			
			CreateCustomGameObjects("Custom", new Vector2(493.8545f, 12.37003f), new Vector2(-46208f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1, "Front", true, 999);
                CreateCustomGameObjects("Custom", new Vector2(597f, 981f), new Vector2(46208f, -1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1, "Front", true, 999);
                CreateCustomGameObjects("Custom", new Vector2(1143.498f, 647.5114f), new Vector2(-46208f, 1f), Quaternion.Euler(0f, 0f, 90f), CustomSprite1, "Front", true, 999);
                CreateCustomGameObjects("Custom", new Vector2(-1.345772f, 588.5825f), new Vector2(-46208f, 1f), Quaternion.Euler(0f, 0f, 270f), CustomSprite1, "Front", true, 999);
                CreateCustomGameObjects("Custom", new Vector2(24f, 15f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(84f, 15f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(144f, 15f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(204f, 15f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(264f, 15f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(324f, 15f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(384f, 15f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(444f, 15f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(504f, 15f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(624f, 15f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(564f, 15f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(684f, 15f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(744f, 15f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(804f, 15f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(864f, 15f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(919.1838f, 6.578829f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 346f), CustomSprite2, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(24f, 24f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(84f, 24f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(144f, 24f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(204f, 24f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(264f, 24f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(324f, 24f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(384f, 24f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(444f, 24f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(504f, 24f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(564f, 24f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(624f, 24f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(684f, 24f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(18f, 27f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(78f, 27f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(138f, 27f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(198f, 27f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(258f, 27f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(318f, 27f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(378f, 27f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(438f, 27f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(498f, 27f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(558f, 27f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(618f, 27f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(678f, 27f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(684f, 27f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(744f, 24f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(803.9185f, 23.63158f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 359.3f), CustomSprite7, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(863.6893f, 21.44667f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 356.5f), CustomSprite7, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(922.4311f, 13.13972f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 347.4f), CustomSprite7, "Front", false, 0);
                CreateCustomGameObjects("Custom", new Vector2(978.9526f, -4.68292f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 337.6f), CustomSprite7, "Front", false, 0);
                CreateWaterBlock(new Vector3(-358.8f, 21.2f, 1f), new Vector3(987f, 15f, 0f), Quaternion.Euler(0f, 0f, 0f), "Water");
                CreateCustomGameObjects("Custom", new Vector2(707.197f, 31.0274f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(16.81495f, 31.09665f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(23.85781f, 26.71561f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 348.8f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(120f, 27f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(123f, 30f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(192f, 24f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(183f, 30f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(594f, 30f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(600.532f, 25.99577f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 320.8f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(585.2874f, 23.32383f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 18.9f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(577.3265f, 24.67799f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 340.4f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(656.8027f, 30.45498f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(201f, 30f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(205.6084f, 27.63143f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 343.2f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(433.4174f, 28.37307f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(438f, 24f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 343.2f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(509.8008f, 26.16939f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 8.4f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(517.1486f, 25.02341f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 1.399999f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(522f, 27f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(249f, 24f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(276f, 24f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8, "Back", true, -9000);
                CreateCustomGameObjects("Custom", new Vector2(6.956717f, 38.73989f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10, "Back", true, -9001);
                CreateCustomGameObjects("Custom", new Vector2(104.1139f, 40.22833f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10, "Back", true, -9001);
                CreateCustomGameObjects("Custom", new Vector2(215.0447f, 38.67744f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10, "Back", true, -9001);
                CreateCustomGameObjects("Custom", new Vector2(629.2401f, 38.36581f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10, "Back", true, -9001);
                CreateCustomGameObjects("Custom", new Vector2(460.9405f, 38.42603f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10, "Back", true, -9001);
                CreateCustomGameObjects("Custom", new Vector2(51.5554f, 40.39972f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite11, "Back", true, -9002);
                CreateCustomGameObjects("Custom", new Vector2(154.4669f, 40.12398f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite11, "Back", true, -9002);
                CreateCustomGameObjects("Custom", new Vector2(586.8499f, 40.15218f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite11, "Back", true, -9002);
                CreateCustomGameObjects("Custom", new Vector2(675.2002f, 39.92405f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite11, "Back", true, -9002);
                CreateCustomGameObjects("Custom", new Vector2(242.8357f, 40.02309f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite11, "Back", true, -9002);
                CreateCustomGameObjects("Custom", new Vector2(114f, 30f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(96f, 30f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(78f, 30f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(60f, 30f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(42f, 30f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(24f, 30f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(6f, 30f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(132f, 30f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(150f, 30f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(168f, 30f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(186f, 30f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(204f, 30f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(219f, 30f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(234f, 30f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(252f, 30f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(270f, 30f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(288f, 30f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(306f, 30f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(324f, 30f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(342f, 30f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(360f, 30f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(378f, 30f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(396f, 30f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(414f, 30f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(432f, 30f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(447f, 30f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(462f, 30f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(477f, 30f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(495f, 30f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(510f, 30f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(525f, 30f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(540f, 30f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(558f, 30f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(576f, 30f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(594f, 30f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(660f, 30f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(612f, 30f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(630f, 30f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(645f, 30f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(675f, 30f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(690f, 30f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
                CreateCustomGameObjects("Custom", new Vector2(705f, 30f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13, "Back", true, -8000);
			CreateLightSourceStreet("Light", new Vector2(306.0159f, 32.1151f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(324.011f, 32.13171f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(342.0126f, 32.15614f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(360.0112f, 32.15615f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(378.0099f, 32.1354f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(396.0164f, 32.18485f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(414.0151f, 32.21426f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(431.9843f, 32.15544f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(447.0126f, 32.12603f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(461.9967f, 32.12603f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(477.0103f, 32.09662f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(495.0237f, 32.11132f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(510.0226f, 32.11132f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(525.0215f, 32.12602f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(540.0203f, 32.15543f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(558.0109f, 32.17536f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(576.0167f, 32.1409f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(594.0225f, 32.15813f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(612.011f, 32.12366f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(630.0168f, 32.15813f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(645.0073f, 32.14089f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(660.0151f, 32.1409f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(675.0179f, 32.14668f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(690.0145f, 32.14668f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(705.0115f, 32.09275f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(288.0119f, 32.13997f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(270.0258f, 32.14213f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(252.0052f, 32.14818f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(234.0067f, 32.12672f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(218.9635f, 32.17132f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(204.019f, 32.11827f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(186.0095f, 32.11827f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(168.0001f, 32.09764f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(150.0113f, 32.1389f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(132.0225f, 32.077f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(114.013f, 32.01511f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(96.00359f, 32.09763f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(78.01478f, 32.077f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(60.00533f, 32.09763f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(42.03716f, 32.09763f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(24.00709f, 32.11826f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
			CreateLightSourceStreet("Light", new Vector2(6.01828f, 32.11826f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 1f);
                CreateCustomGameObjects("Custom", new Vector2(533.7784f, 38.82313f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10, "Back", true, -9001);
                CreateCustomGameObjects("Custom", new Vector2(293.19f, 38.76213f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10, "Back", true, -9001);
                CreateCustomGameObjects("Custom", new Vector2(503.386f, 38.28427f), new Vector2(-1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite11, "Back", true, -9002);
                CreateLightSources("Light", new Vector2(259.9728f, 37.21576f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(254.0389f, 40.50346f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(253.5556f, 36.70957f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(252.6615f, 40.76928f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(217.4532f, 40.26181f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(205.0083f, 42.96829f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(206.0474f, 38.06281f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(218.0573f, 31.61077f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(231.9763f, 42.00169f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(235.1178f, 43.16161f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(232.0005f, 46.27888f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(233.1846f, 36.08128f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(247.9494f, 36.58874f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(254.8478f, 33.12079f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(242.3001f, 49.47695f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(251.8412f, 51.72191f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(244.7054f, 55.73077f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(241.0173f, 36.12744f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(238.4115f, 38.0116f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(236.808f, 41.69975f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(236.5273f, 32.19875f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(295.5779f, 44.10508f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(279.5024f, 34.68425f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(296.2594f, 31.79787f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(297.0612f, 30.39477f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(295.2572f, 40.37684f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(283.0703f, 39.89577f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(287.0791f, 41.98038f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(288.3218f, 49.47695f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(290.4866f, 54.76865f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(242.3001f, 50.96024f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(251.8813f, 50.67962f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(250.4381f, 48.2743f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(310.9215f, 30.95192f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(298.7088f, 35.07743f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(290.3759f, 34.39441f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(211.0266f, 34.46619f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(214.1955f, 46.19097f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(215.3273f, 50.5821f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(214.0144f, 40.6681f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(216.5495f, 34.42093f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(161.5879f, 37.5821f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(166.2031f, 41.35338f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(164.9636f, 40.40396f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(153.0695f, 41.66984f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(148.6126f, 36.10524f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(145.6852f, 48.13112f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(143.8655f, 47.55093f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(146.1072f, 45.20377f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(144.1293f, 40.24573f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(146.5028f, 39.08534f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(144.4194f, 37.47661f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(101.0102f, 33.17788f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(101.7223f, 45.62573f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(113.6426f, 44.72906f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(114.2756f, 38.21504f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(105.2562f, 47.60367f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(105.5175f, 55.9745f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(98.31853f, 35.61895f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(83.17599f, 36.73603f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(76.84592f, 33.13657f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(63.37898f, 39.65283f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(53.57357f, 52.87152f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(50.905f, 54.60919f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(52.51855f, 57.65011f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(49.10527f, 45.36231f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(40.66516f, 42.44551f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(43.33373f, 39.96312f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(51.1791f, 35.63963f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(42.41835f, 34.37258f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(29.63923f, 35.20521f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(23.62979f, 37.73932f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(21.78352f, 34.48118f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(29.96505f, 31.58507f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(43.35958f, 47.1879f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(52.04793f, 39.44078f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(46.40051f, 38.60815f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(45.92989f, 34.77079f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(58.09358f, 37.12389f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(51.0705f, 49.07037f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(62.40155f, 35.13281f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(69.53323f, 36.90668f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(76.91833f, 35.67583f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(83.97762f, 34.98801f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(89.40784f, 31.94708f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(98.4582f, 36.90668f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(28.11744f, 34.93659f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(9.213564f, 44.18711f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(0.6168923f, 41.8108f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(9.248508f, 37.93182f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(-2.216637f, 36.6825f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(4.102735f, 29.75157f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(10.95212f, 31.4843f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(4.408511f, 40.75951f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(2.186539f, 49.81048f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(6.773178f, 53.15363f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(451.3017f, 40.73579f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(446.5703f, 34.43486f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(463.3727f, 38.63548f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(462.865f, 42.74377f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(450.7478f, 34.31946f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(443.2698f, 32.31148f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(458.5259f, 44.91332f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(455.6408f, 47.22135f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(458.2027f, 54.53781f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(461.5724f, 50.59108f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(458.6874f, 36.78905f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(478.2978f, 35.39768f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(472.9333f, 31.79583f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(485.5015f, 35.47431f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(492.1305f, 39.45934f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(492.0921f, 34.97618f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(496.8052f, 35.0145f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(493.8931f, 33.09862f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(497.8015f, 30.60798f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(487.4174f, 31.87246f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(494.0464f, 45.28361f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(501.6332f, 50.03498f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(504.1239f, 46.70136f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(503.894f, 53.63684f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(508.1472f, 39.53597f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(511.4042f, 42.40979f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(513.1668f, 39.30607f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(510.9443f, 35.70422f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(504.4687f, 35.32104f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(500.2538f, 48.84714f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(501.5183f, 54.09665f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(513.3967f, 32.44722f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(531.8658f, 44.13408f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(538.6097f, 47.73594f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(530.6396f, 31.75751f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(561.6213f, 37.10099f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(577.8171f, 51.90598f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(575.5739f, 41.22844f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(568.9341f, 35.44104f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(597.243f, 45.93912f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(594.596f, 43.33703f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(596.929f, 38.89553f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(579.2975f, 35.26158f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(580.3743f, 51.86111f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(585.6682f, 46.02885f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(616.9829f, 36.06913f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(609.5804f, 34.85781f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(612.9003f, 33.91568f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(627.1221f, 42.66408f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(638.1585f, 42.12571f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(639.4147f, 37.90854f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(633.0889f, 34.85781f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(629.4999f, 49.34875f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(630.0382f, 42.84353f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(630.6663f, 53.52107f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(632.0571f, 46.7018f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(651.3036f, 34.22972f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(664.5833f, 44.63808f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(667.0956f, 45.89426f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(667.0956f, 38.98526f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(686.9253f, 41.13871f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(665.9739f, 33.87081f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(675.171f, 35.53076f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(670.6846f, 39.34417f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(667.4545f, 47.46448f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(664.5832f, 37.14585f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(691.1873f, 32.79408f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(693.6996f, 36.83181f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(685.8934f, 34.63349f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(683.1567f, 34.13999f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(674.4083f, 54.37347f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(684.4129f, 46.43261f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(678.0423f, 39.92739f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(700.6536f, 36.69722f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(702.3135f, 34.90268f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
                CreateLightSources("Light", new Vector2(693.2062f, 35.21672f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 247, 184, 255), 1f);
			CreateBackground("Background", new Color32(byte.MaxValue, byte.MaxValue, byte.MaxValue, (byte)10), ASS, true);
		}
	}
	public class MapModManager : MonoBehaviour
	{
		private void Start()
		{
			var clearButton = GameObject.Find("Canvas/Catalog/settings/clear/Clear Everything");
			clearButton.GetComponent<Button>().onClick.AddListener(() => Mod.InitilizeMap());
			Mod.InitilizeMap();
		}
		private void OnDestroy()
		{
			if(MapLoaderBehaviour.CurrentMap.name == Mod.MapModName)
			{
				var manager = new GameObject("managerMap");
				manager.AddComponent<MapModManager>();
			}
		}
	}

	public class TestDelay : MonoBehaviour
	{
		public void Awake()
		{
			StartCoroutine(Delay());
		}

		public IEnumerator Delay()
		{
			yield return new WaitForSeconds(0f);
			foreach (var Rig in this.gameObject.GetComponentsInChildren<Rigidbody2D>())
			{
				Rig.bodyType = RigidbodyType2D.Static;
			}
		}
	}

	public class ParticleDelay : MonoBehaviour
	{
		public string Particles1;
		public float Speed1;
		public void Awake()
		{
			StartCoroutine(Emit());
		}

		public IEnumerator Emit()
		{
			yield return new WaitForSeconds(0.25f);
			while (true)
			{
				var time = 1f / Speed1;
				ModAPI.CreateParticleEffect(Particles1.ToString(), gameObject.transform.position);
				yield return new WaitForSeconds(time);
			}
		}
	}

	public class LavaBurn : MonoBehaviour
	{
		private void FixedUpdate()
		{
			foreach (PhysicalBehaviour physicalBehaviour in Global.main.PhysicalObjectsInWorld)
			{
				if (!physicalBehaviour)
				{
					break;
				}
				foreach (Vector2 v in physicalBehaviour.LocalColliderGridPoints)
				{
					Vector3 vector = physicalBehaviour.transform.TransformPoint(v);
					if (vector.y <= gameObject.GetComponent<WaterBlockBehaviour>().GlobalTop && vector.y >= gameObject.GetComponent<WaterBlockBehaviour>().GlobalBottom && vector.x >= gameObject.GetComponent<WaterBlockBehaviour>().GlobalLeft && vector.x <= gameObject.GetComponent<WaterBlockBehaviour>().GlobalRight)
					{
						if (physicalBehaviour.BurnProgress < 0.95f)
						{
							if (physicalBehaviour.Properties.Flammability > 0.1f)
							{
								physicalBehaviour.BurnProgress += 0.01f;
								physicalBehaviour.Ignite();
								physicalBehaviour.burnIntensity = 2f;
							}
							physicalBehaviour.Temperature += 10f;
							if (physicalBehaviour.gameObject.GetComponent<LimbBehaviour>())
							{
								physicalBehaviour.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().AddPain(5f);
							}
						}
					}
				}
			}
		}
	}

	public class AcidBurn : MonoBehaviour
	{
		public float a = 1;
		public float b = 1;
		public Color ACIDCOLOR = new Color(1, 1, 1, 1);

		private void FixedUpdate()
		{
			foreach (PhysicalBehaviour physicalBehaviour in Global.main.PhysicalObjectsInWorld)
			{
				if (!physicalBehaviour)
				{
					break;
				}
				if (physicalBehaviour.transform.root.gameObject.GetComponent<WaterBlockBehaviour>())
				{
					continue;
				}
				foreach (Vector2 v in physicalBehaviour.LocalColliderGridPoints)
				{
					Vector3 vector = physicalBehaviour.transform.TransformPoint(v);
					if (vector.y <= gameObject.GetComponent<WaterBlockBehaviour>().GlobalTop && vector.y >= gameObject.GetComponent<WaterBlockBehaviour>().GlobalBottom && vector.x >= gameObject.GetComponent<WaterBlockBehaviour>().GlobalLeft && vector.x <= gameObject.GetComponent<WaterBlockBehaviour>().GlobalRight)
					{
						if (physicalBehaviour.gameObject.GetComponent<LimbBehaviour>() != null && !physicalBehaviour.isDisintegrated)
						{
							float random = UnityEngine.Random.Range(1f, 10f);
							var limb = physicalBehaviour.gameObject.GetComponent<LimbBehaviour>();
							var skin = physicalBehaviour.gameObject.GetComponent<SkinMaterialHandler>();
							if (physicalBehaviour.gameObject.name == "Head" || physicalBehaviour.gameObject.name == "Foot" || physicalBehaviour.gameObject.name == "FootFront")
							{
								limb.SkinMaterialHandler.AcidProgress += Time.deltaTime * 0.025f;
								limb.SkinMaterialHandler.RottenProgress += Time.deltaTime * 0.025f;
							}
							else
							{
								limb.SkinMaterialHandler.AcidProgress += Time.deltaTime * 0.005f;
								limb.SkinMaterialHandler.RottenProgress += Time.deltaTime * 0.005f;
							}
							limb.Wince(limb.SkinMaterialHandler.AcidProgress * 100f);
							if (limb.SkinMaterialHandler.AcidProgress > 0.75f)
							{
								limb.BreakBone();
								limb.Health = 0f;
							}
							physicalBehaviour.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().AddPain(10f);
							if (limb.Person.OxygenLevel <= 0.7f && !physicalBehaviour.isDisintegrated && physicalBehaviour.gameObject.name != "Head")
							{
								if (limb.Health <= 0f)
								{
									if (skin.RottenProgress >= 0.7f)
									{
										if (skin.AcidProgress >= 0.9f)
										{
											if (physicalBehaviour.gameObject.transform.lossyScale.x < 0f && physicalBehaviour.gameObject.GetComponent<LimbBehaviour>() == null)
											{
												physicalBehaviour.gameObject.transform.localScale = new Vector2(Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.x + 0.005f, -500000f, 0f), Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.y - 0.005f, 0f, 5000000f));
												if (physicalBehaviour.gameObject.transform.localScale.x == 0 && physicalBehaviour.gameObject.transform.localScale.y == 0)
												{
													AudioSource.PlayClipAtPoint(Mod.acidhiss, physicalBehaviour.gameObject.transform.position, 6f);
													physicalBehaviour.Disintegrate();
													break;
												}
											}
											else
											{
												physicalBehaviour.gameObject.transform.localScale = new Vector2(Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.x - 0.005f, 0, 5000000f), Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.y - 0.005f, 0f, 5000000f));
												if (physicalBehaviour.gameObject.transform.localScale.x == 0 && physicalBehaviour.gameObject.transform.localScale.y == 0)
												{
													AudioSource.PlayClipAtPoint(Mod.acidhiss, physicalBehaviour.gameObject.gameObject.transform.position, 6f);
													physicalBehaviour.Disintegrate();
													break;
												}
											}
										}
									}
								}
							}
						}
						else if (physicalBehaviour.Properties.Flammability > 0.1f && !physicalBehaviour.isDisintegrated)
						{
							if (physicalBehaviour.gameObject.transform.lossyScale.x < 0f && physicalBehaviour.gameObject.GetComponent<LimbBehaviour>() == null)
							{
								physicalBehaviour.gameObject.transform.localScale = new Vector2(Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.x + 0.0005f, -500000f, 0f), Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.y - 0.0005f, 0f, 5000000f));
								if (physicalBehaviour.gameObject.transform.localScale.x == 0 && physicalBehaviour.gameObject.transform.localScale.y == 0)
								{
									AudioSource.PlayClipAtPoint(Mod.acidhiss, physicalBehaviour.gameObject.transform.position, 6f);
									physicalBehaviour.Disintegrate();
									a = 1;
									b = 1;
									break;
								}
							}
							else
							{
								physicalBehaviour.gameObject.transform.localScale = new Vector2(Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.x - 0.0005f, 0, 5000000f), Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.y - 0.0005f, 0f, 5000000f));
								if (physicalBehaviour.gameObject.transform.localScale.x == 0 && physicalBehaviour.gameObject.transform.localScale.y == 0)
								{
									AudioSource.PlayClipAtPoint(Mod.acidhiss, physicalBehaviour.gameObject.gameObject.transform.position, 6f);
									physicalBehaviour.Disintegrate();
									a = 1;
									b = 1;
									break;
								}
							}
						}
					}
				}
			}
		}
	}

	public class WaterBlockBehaviour : MonoBehaviour
	{
		public bool IsEvaporated
		{
			get
			{
				if (this.Lava == false)
				{
					return PhysicalBehaviour.AmbientTemperature > 200f;
				}
				else
				{
					return false;
				}
			}
		}

		public bool IsFrozen
		{
			get
			{
				if (this.Lava == false)
				{
					return PhysicalBehaviour.AmbientTemperature < 0f;
				}
				else
				{
					return false;
				}
			}
		}

		private void Awake()
		{
			if (base.gameObject.activeInHierarchy)
			{
				WaterBlockBehaviour.Instance = this;
			}
		}

		private void Start()
		{
			this.SpriteRenderer = base.GetComponent<SpriteRenderer>();
			if (base.gameObject.activeInHierarchy)
			{
				this.waterSizzles = Resources.LoadAll<AudioClip>("Audio/water_sizzle");
				WaterBlockBehaviour.Instance = this;
			}
			UpdateTemperatureState();
		}

		public static bool IsPointUnderWater(Vector3 pos)
		{
			return !WaterBlockBehaviour.Instance.IsEvaporated && !WaterBlockBehaviour.Instance.IsFrozen && pos.y < WaterBlockBehaviour.Instance.GlobalTop && pos.y > WaterBlockBehaviour.Instance.GlobalBottom && pos.x < WaterBlockBehaviour.Instance.GlobalRight && pos.x > WaterBlockBehaviour.Instance.GlobalLeft;
		}

		public static float GetWaterLevelOr(float fallback = -3.40282347E+38f)
		{
			if (!WaterBlockBehaviour.Instance)
			{
				return fallback;
			}
			if (WaterBlockBehaviour.Instance.IsEvaporated || WaterBlockBehaviour.Instance.IsFrozen)
			{
				return fallback;
			}
			return WaterBlockBehaviour.Instance.GlobalTop;
		}

		private void OnTriggerEnter2D(Collider2D collision)
		{
			if (!this.IsEvaporated && !this.IsFrozen)
			{
				this.DoSplash(collision);
			}
		}

		private void OnTriggerExit2D(Collider2D collision)
		{
			if (!this.IsEvaporated && !this.IsFrozen)
			{
				this.DoSplash(collision);
			}
		}

		private void DoSplash(Collider2D collision)
		{
			if (!UserPreferenceManager.Current.FancyEffects)
			{
				return;
			}
			if (collision.isTrigger)
			{
				return;
			}
			PhysicalBehaviour physicalBehaviour;
			if (!Global.main.PhysicalObjectsInWorldByTransform.TryGetValue(collision.transform, out physicalBehaviour))
			{
				return;
			}
			Rigidbody2D rigidbody = physicalBehaviour.rigidbody;
			GameObject gameObject = UnityEngine.Object.Instantiate<GameObject>(this.Splash, this.Trigger.bounds.ClosestPoint(collision.transform.position), Quaternion.identity);
			gameObject.SetActive(true);
			Vector2 velocity = rigidbody.velocity;
			velocity.y = -Mathf.Abs(velocity.y);
			gameObject.transform.up = Vector2.Reflect(velocity, Vector2.up);
			float num = Mathf.Min(collision.bounds.extents.x, 4f);
			float num2 = Mathf.Clamp(rigidbody.velocity.magnitude * 0.5f * rigidbody.mass, 0.2f, 25f);
			gameObject.GetComponent<AudioSource>().volume = num2 / 15f;
			foreach (ParticleSystem particleSystem in gameObject.GetComponentsInChildren<ParticleSystem>())
			{
				ParticleSystem.ShapeModule shape = particleSystem.shape;
				ParticleSystem.MainModule main = particleSystem.main;
				shape.radius = num;
				main.startSizeMultiplier = num * 2.5f * UnityEngine.Random.Range(1f, 1.4f);
				main.startSpeedMultiplier = num2;
			}
		}

		public void UpdateTemperatureState()
		{
			if (this.IsFrozen)
			{
				this.SetFrozen();
				return;
			}
			this.Ice.gameObject.SetActive(false);
			if (this.wasFrozen)
			{
				foreach (PhysicalBehaviour physicalBehaviour in this.frozenInIce)
				{
					if (!physicalBehaviour)
					{
						return;
					}
					FrozenInIceBehaviour obj;
					if (physicalBehaviour.TryGetComponent<FrozenInIceBehaviour>(out obj))
					{
						UnityEngine.Object.Destroy(obj);
						FreezeStackController.RequestUnfreeze(physicalBehaviour.rigidbody);
					}
				}
				this.wasFrozen = false;
			}
			this.frozenInIce.Clear();
			if (this.IsEvaporated)
			{
				this.SetEvaporated();
				return;
			}
			this.BoilingWaterSound.SetActive(PhysicalBehaviour.AmbientTemperature >= 100f);
			foreach (var renderer in base.GetComponents<Renderer>())
			{
				if (renderer != this.SpriteRenderer)
				{
					renderer.enabled = true;
				}
			}
			this.Trigger.enabled = true;
			this.Trigger.isTrigger = true;
			this.SpriteRenderer.enabled = true;
			GameObject[] objectsToBeActiveIfWater = this.ObjectsToBeActiveIfWater;
			for (int i = 0; i < objectsToBeActiveIfWater.Length; i++)
			{
				objectsToBeActiveIfWater[i].SetActive(true);
			}
		}

		private void SetEvaporated()
		{
			this.BoilingWaterSound.SetActive(false);
			foreach (var renderer in base.GetComponents<Renderer>())
			{
				if (renderer != this.SpriteRenderer)
				{
					renderer.enabled = false;
				}
			}
			this.Trigger.enabled = false;
			this.SpriteRenderer.enabled = false;
			GameObject[] objectsToBeActiveIfWater = this.ObjectsToBeActiveIfWater;
			for (int i = 0; i < objectsToBeActiveIfWater.Length; i++)
			{
				objectsToBeActiveIfWater[i].SetActive(false);
			}
		}

		private void SetFrozen()
		{
			this.BoilingWaterSound.SetActive(false);
			foreach (var renderer in base.GetComponents<Renderer>())
			{
				if (renderer != this.SpriteRenderer)
				{
					renderer.enabled = false;
				}
			}
			this.Ice.gameObject.SetActive(true);
			this.wasFrozen = true;
			this.Trigger.isTrigger = false;
			this.SpriteRenderer.enabled = true;
			GameObject[] objectsToBeActiveIfWater = this.ObjectsToBeActiveIfWater;
			for (int i = 0; i < objectsToBeActiveIfWater.Length; i++)
			{
				objectsToBeActiveIfWater[i].SetActive(false);
			}
			foreach (PhysicalBehaviour physicalBehaviour in Global.main.PhysicalObjectsInWorld)
			{
				if (!this.frozenInIce.Contains(physicalBehaviour))
				{
					int num = 0;
					int num2 = physicalBehaviour.LocalColliderGridPoints.Length;
					foreach (Vector2 v in physicalBehaviour.LocalColliderGridPoints)
					{
						if (physicalBehaviour.transform.TransformPoint(v).y <= this.GlobalTop && physicalBehaviour.transform.TransformPoint(v).y >= this.GlobalBottom && physicalBehaviour.transform.TransformPoint(v).x >= this.GlobalLeft && physicalBehaviour.transform.TransformPoint(v).y <= this.GlobalRight)
						{
							num++;
							if ((float)num / (float)num2 >= 0.1f)
							{
								physicalBehaviour.rigidbody.velocity = default(Vector2);
								physicalBehaviour.rigidbody.angularVelocity = 0f;
								FreezeStackController.RequestFreeze(physicalBehaviour.rigidbody);
								this.frozenInIce.Add(physicalBehaviour);
								physicalBehaviour.gameObject.AddComponent<FrozenInIceBehaviour>();
								physicalBehaviour.Temperature = Mathf.Min(physicalBehaviour.Temperature, PhysicalBehaviour.AmbientTemperature);
								break;
							}
						}
					}
				}
			}
		}

		private void FixedUpdate()
		{
			if (this.IsFrozen)
			{
				this.Ice.Temperature = PhysicalBehaviour.AmbientTemperature;
				foreach (PhysicalBehaviour physicalBehaviour in this.frozenInIce)
				{
					if (!physicalBehaviour)
					{
						return;
					}
					if (physicalBehaviour.OnFire)
					{
						physicalBehaviour.Extinguish();
					}
					FrozenInIceBehaviour obj;
					if (physicalBehaviour.transform.position.y > this.GlobalTop && physicalBehaviour.transform.position.y < this.GlobalBottom && physicalBehaviour.transform.position.y < this.GlobalRight && physicalBehaviour.transform.position.y > this.GlobalLeft && physicalBehaviour.TryGetComponent<FrozenInIceBehaviour>(out obj))
					{
						UnityEngine.Object.Destroy(obj);
						FreezeStackController.RequestUnfreeze(physicalBehaviour.rigidbody);
					}
				}
				return;
			}
			if (this.IsEvaporated)
			{
				return;
			}
			Vector3 a = Vector3.up * this.Buoyancy;
			float num = Mathf.Min(PhysicalBehaviour.AmbientTemperature, 100f);
			bool flag = PhysicalBehaviour.AmbientTemperature >= 100f;
			foreach (PhysicalBehaviour physicalBehaviour2 in Global.main.PhysicalObjectsInWorld)
			{
				if (!physicalBehaviour2)
				{
					break;
				}
				float num2 = Mathf.Clamp(Mathf.Pow(Mathf.Abs(physicalBehaviour2.transform.position.y - this.GlobalTop), 0.25f), 1f, 8f);
				float d = Mathf.Clamp01((num2 - 1f) / 7f) + 1f;
				Vector2 force = a * physicalBehaviour2.Properties.Buoyancy * physicalBehaviour2.rigidbody.mass / (float)physicalBehaviour2.LocalGridPointLength * num2;
				bool flag2 = false;
				physicalBehaviour2.CurrentWaterSurfaceLevel = this.GlobalTop;
				foreach (Vector2 v in physicalBehaviour2.LocalColliderGridPoints)
				{
					Vector3 vector = physicalBehaviour2.transform.TransformPoint(v);
					if (vector.y <= this.GlobalTop && vector.y >= this.GlobalBottom && vector.x <= this.GlobalRight && vector.x >= this.GlobalLeft)
					{
						flag2 = true;
						physicalBehaviour2.rigidbody.AddForceAtPosition(force, vector);
						Vector2 pointVelocity = physicalBehaviour2.rigidbody.GetPointVelocity(vector);
						physicalBehaviour2.rigidbody.AddForceAtPosition(-pointVelocity * d * this.GetDragFactor(pointVelocity) * physicalBehaviour2.rigidbody.mass * 0.4f, vector);
					}
				}
				bool flag3 = !physicalBehaviour2.IsUnderWater;
				physicalBehaviour2.IsUnderWater = flag2;
				if (flag2)
				{
					AliveBehaviour aliveBehaviour;
					if (flag && AliveBehaviour.AliveByTransform.TryGetValue(physicalBehaviour2.transform.root, out aliveBehaviour))
					{
						physicalBehaviour2.BurnProgress = Mathf.Max(physicalBehaviour2.BurnProgress, 0.5f);
						aliveBehaviour.SendMessage("AddPain", 15f, SendMessageOptions.DontRequireReceiver);
					}
					physicalBehaviour2.Temperature = Mathf.Lerp(physicalBehaviour2.Temperature, num, 0.05f * physicalBehaviour2.Properties.HeatTransferSpeedMultiplier);
					if (flag3 && physicalBehaviour2.Temperature >= 100f && physicalBehaviour2.Temperature > num * 2f)
					{
						physicalBehaviour2.PlayClipOnce(this.waterSizzles.PickRandom<AudioClip>(), 1f);
						physicalBehaviour2.Sizzle(false);
					}
					physicalBehaviour2.Wetness += 0.1f;
					physicalBehaviour2.SendMessage("WaterImpact", physicalBehaviour2.rigidbody.velocity.magnitude, SendMessageOptions.DontRequireReceiver);
					physicalBehaviour2.SendMessage("Suspended", SendMessageOptions.DontRequireReceiver);
				}
			}
		}

		private void Update()
		{
			UpdateTemperatureState();
		}

		private float GetDragFactor(Vector2 velocity)
		{
			float num = velocity.sqrMagnitude * 0.1f;
			return Mathf.Clamp(Mathf.Pow(num + 1f, num * this.Drag), 0.2f, 1f);
		}

		private void OnWillRenderObject()
		{
			if (!this.mat)
			{
				this.mat = this.SpriteRenderer.material;
			}
			if (this.mat)
			{
				this.mat.SetFloat("_Temperature", PhysicalBehaviour.AmbientTemperature);
			}
		}

		public float Drag;
		public float Buoyancy;
		public float GlobalTop;
		public float GlobalBottom;
		public float GlobalLeft;
		public float GlobalRight;
		public Vector2 WaterCenter;
		public Vector2 WaterSize;
		public bool Lava = false;
		public GameObject[] ObjectsToBeActiveIfWater;
		public GameObject Splash;
		public GameObject BoilingWaterSound;
		public SpriteRenderer SpriteRenderer;
		public Collider2D Trigger;
		public Collider2D[] insideWater = new Collider2D[1024];
		public LayerMask Layers;
		public PhysicalBehaviour Ice;
		private bool wasFrozen;
		private AudioClip[] waterSizzles;
		private HashSet<PhysicalBehaviour> frozenInIce = new HashSet<PhysicalBehaviour>();
		private Material mat;
		public static WaterBlockBehaviour Instance;
	}
}

